#!/usr/bin/python
import os
import location
import urllib
import gobject
import trackerconstants
from urllib import urlopen
from xml.dom import minidom   


def get_addr_from_xml(xml):
    xmldoc = minidom.parseString(xml)
    print xmldoc.toxml()
    addressobj=xmldoc.firstChild.childNodes[1]
    print addressobj.childNodes
    street=addressobj.childNodes[1]
    streetnumber=addressobj.childNodes[3]
    postalcode=addressobj.childNodes[11]
    city=addressobj.childNodes[13]
    state=addressobj.childNodes[21]
    country=addressobj.childNodes[23]
    address="%s %s, %s, %s, %s" % (streetnumber.firstChild.data,street.firstChild.data,city.firstChild.data,state.firstChild.data,country.firstChild.data)
    #print address
    return address

def getLocation():
    if not device:
        return ""
    if device.fix[1] & location.GPS_DEVICE_LATLONG_SET:
        if trackerconstants.c_debug == 1 :
            print "Getting Location from GPS"
        print "lat = %f, long = %f" % device.fix[4:6]
        lat= device.fix[4]
        lng= device.fix[5]
        print "lat = %f, long = %f" % (lat,lng)
        return (lat,lng)
        #return "%s=&lng=%f" % device.fix[4:6]

def start_location(data):
    data.start()
    return False

def on_stop(control, data):
    if trackerconstants.c_debug == 1 :
        print "quitting"
    data.quit()



if 1:
    control = location.GPSDControl.get_default()
    device = location.GPSDevice()
    control.set_properties(preferred_method=location.METHOD_USER_SELECTED,
                           preferred_interval=location.INTERVAL_DEFAULT)

    #control.connect("error-verbose", on_error, loop)
    #device.connect("changed", on_changed, control)
    #control.connect("gpsd-stopped", on_stop, loop)

    gobject.idle_add(start_location, control)


f=os.popen('dbus-send --system --type=method_call --print-reply=True --dest=com.nokia.phone.SIM /com/nokia/phone/SIM Phone.Sim.get_imsi')

for i in f.readlines():
   msg=i.strip()
   parts=msg.split(" ")
   imei=parts[0]

f=os.popen('dbus-send --system --type=method_call --print-reply=True --dest=com.nokia.phone.SIM /com/nokia/phone/SIM/security Phone.Sim.Security.get_imei')
for i in f.readlines():
   msg=i.strip()
   parts=msg.split(" ")
   imsi=parts[0]

(lat,lng)=getLocation()
ll="%s,%s" % (lat,lng)
#url = "http://ws.geonames.org/extendedFindNearby?lat=%s&lng=%s" % (lat,lng)
#url = "http://ws.geonames.org/findNearestAddress?lat=%s&lng=%s" % (lat,lng)
if trackerconstants.c_debug == 1 :
    #print "Call %s" % url
#addrxml=urlopen(url).read()
#addr=get_addr_from_xml(addrxml)
#if addr=="":
    msg="Phone is located at lat/long of %s" % ll
#if addr!="":
#    msg="Phone is located at %s (%s)" % (addr,ll)

if trackerconstants.c_debug == 1 :
    print "%s" % msg
#addr=urllib.quote(addr);
url = "%s?IMEI=%s&IMSI=%s&ll=%s&Pass=%s" % (trackerconstants.c_apiurl,imei,imsi, ll, trackerconstants.c_password)
#url = "%s?IMEI=%s&IMSI=%s&ll=%s&addr=%s&Pass=%s" % (trackerconstants.c_apiurl,imei,imsi, ll, addr,trackerconstants.c_password)
if trackerconstants.c_debug == 1 :
    print "Call %s" % url
mode=urlopen(url).read()

